#include <Arduino.h>

class Timer{
private:
	unsigned long _interval, _lastTick;
	void (*_callback)(void);
	bool _running;

public:
	Timer(void (*callback)(void)){
		_callback = callback;
		_running = false;
	}

	void reset(unsigned long interval){
		_interval = interval;
		_lastTick = millis();
		_running = true;
	}

	void loop(){
		if (!_running)
			return;
			
		unsigned long tick = millis();

		if (tick - _lastTick >= _interval){
			_callback();
			_running = false;
		}
	}
};
